BEGIN
	SET TRANSACTION READ WRITE;
		MERGE INTO "SysWidgetDashboard" Target
			USING (			
				SELECT 
					"Id", "ViewConfig", "Items", "Caption"
				FROM "SysDashboard"
				WHERE "SectionId" IS NULL) Source
			ON (Target."Id" = Source."Id")
			WHEN MATCHED THEN
			UPDATE SET
				"ViewConfig" = Source."ViewConfig",
				"Items" = Source."Items",
				"Caption" = Source."Caption"
			WHEN NOT MATCHED THEN
			INSERT ("Id", "ViewConfig", "Items", "Caption")
			VALUES (Source."Id", Source."ViewConfig", Source."Items", Source."Caption");
		MERGE INTO "SysWidgetDashboardLcz" Target
			USING (			
			SELECT 
				"Id", "RecordId", "SysCultureId", "Caption", "Items"
			FROM "SysDashboardLcz" 
			WHERE "RecordId" IN (
				SELECT 
					"Id"
				FROM "SysWidgetDashboard")) Source
			ON (Target."SysCultureId" = Source."SysCultureId" 
				AND Target."RecordId" = Source."RecordId")
			WHEN MATCHED THEN
			UPDATE SET
				"Caption" = Source."Caption",
				"Items" = Source."Items"
			WHEN NOT MATCHED THEN
			INSERT ("Id", "RecordId", "SysCultureId", "Caption", "Items")
			VALUES (Source."Id", Source."RecordId", Source."SysCultureId", Source."Caption", Source."Items");
		DELETE FROM "SysDashboard"
			WHERE "SectionId" IS NULL;
		DELETE FROM "SysDashboardLcz"
			WHERE "RecordId" IN (
				SELECT 
					"Id" 
				FROM "SysWidgetDashboard");
	COMMIT;
	EXCEPTION
		WHEN OTHERS THEN
			ROLLBACK;
			RAISE;
END;