﻿DECLARE
	TABLE_EXISTS NUMBER := 0;
	SYS_PROFILE_DATA_COUNT NUMBER := 0;
	TIME_ZONE_MIGRATION_KEY NVARCHAR2(250) := N'CampaignTimeZoneMigrationTo7120';
	OBJECT_DATA_JSON NVARCHAR2(250) := N'{"CampaignTimeZoneMigrationTo7120":true}';
BEGIN
	BEGIN
		SELECT COUNT(*)
			INTO TABLE_EXISTS FROM USER_OBJECTS 
		WHERE OBJECT_NAME = 'Campaign' AND OBJECT_TYPE = 'TABLE';
		EXCEPTION
			WHEN NO_DATA_FOUND THEN RETURN;
	END;

	BEGIN
		SELECT COUNT("Id") INTO SYS_PROFILE_DATA_COUNT 
		FROM "SysProfileData"
		WHERE "Key" = TIME_ZONE_MIGRATION_KEY;
	
		EXCEPTION
			WHEN NO_DATA_FOUND THEN RETURN;
	END;

	IF SYS_PROFILE_DATA_COUNT = 0 AND TABLE_EXISTS > 0 THEN
		BEGIN
			SAVEPOINT BeforeInsertMigrationData;
			INSERT INTO "SysProfileData"("Key", "ObjectData", "ContactId")
			SELECT
				DISTINCT
				TIME_ZONE_MIGRATION_KEY,
				utl_raw.cast_to_raw(OBJECT_DATA_JSON),
				cont."Id" FROM "Campaign" cmgn, "Contact" cont, "SysSchema" ss
			WHERE 
				(ss."ManagerName" = N'CampaignSchemaManager'
					AND (ss."CreatedById" = cont."Id"
						OR ss."ModifiedById" = cont."Id"))
				OR cont."Id" = cmgn."ModifiedById"
				OR cont."Id" = cmgn."CreatedById"
				OR cont."Id" = cmgn."OwnerId";
			
		EXCEPTION
			WHEN OTHERS THEN
				ROLLBACK TO BeforeInsertMigrationData;
		END;
	END IF;
END;
