DECLARE 
	v_lczTableName VARCHAR2(250);
	v_lczBackupTableName VARCHAR2(250);
	v_lczShortBackupTableName VARCHAR2(250);
	v_lczShortOldBackupTableName VARCHAR2(250);
	v_lczOldTableName VARCHAR2(250);
	v_lczOldBackupTableName VARCHAR2(250);
	v_AllEmployees VARCHAR2(38) := '{A29A3BA5-4B0D-DE11-9A51-005056C00008}';
	v_primaryCulture VARCHAR2(38);
BEGIN
	IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
		RETURN;
	END IF;
	BEGIN
		SELECT "GuidValue" into v_primaryCulture
		FROM "SysSettingsValue" v 
			JOIN "SysSettings" s ON v."SysSettingsId" = s."Id"
		WHERE s."Code" = 'PrimaryCulture' AND v."SysAdminUnitId" = v_AllEmployees AND ROWNUM = 1;
		EXCEPTION WHEN NO_DATA_FOUND THEN v_primaryCulture := '';
	END;
	
	DECLARE CURSOR LczTablesCursor IS 
		SELECT DISTINCT "SourceName" FROM "BakTableNames";
		BEGIN
			OPEN LczTablesCursor;
			LOOP
				FETCH LczTablesCursor INTO v_lczTableName;
				EXIT WHEN LczTablesCursor%NOTFOUND;
				v_lczTableName:= v_lczTableName || 'Lcz';
				v_lczOldBackupTableName := v_lczTableName || 'OldBackup';
				v_lczBackupTableName := v_lczTableName || 'Backup';
				v_lczOldTableName := v_lczTableName || 'Old';
        
				EXECUTE IMMEDIATE 'SELECT "ShortName" FROM "BakTableNames" WHERE "BackupName" = ''' || v_lczBackupTableName || ''' AND ROWNUM = 1' INTO v_lczShortBackupTableName;
				DBMS_OUTPUT.PUT_LINE('Short Backup Table Name: ' || v_lczShortBackupTableName);
				EXECUTE IMMEDIATE 'SELECT "ShortName" FROM "BakTableNames" WHERE "BackupName" = ''' || v_lczOldBackupTableName || ''' AND ROWNUM = 1' INTO v_lczShortOldBackupTableName;
				DBMS_OUTPUT.PUT_LINE('Short Old Backup Table Name: ' || v_lczShortOldBackupTableName);

				"tspkg_Update77To78"."tsp_RestoreTableData"(v_lczShortOldBackupTableName, v_lczOldTableName, v_primaryCulture);
				"tspkg_Update77To78"."tsp_RestoreTableData"(v_lczShortBackupTableName, v_lczTableName, v_primaryCulture);
			END LOOP;
		END;
END;
