DECLARE
  lyc_exst NUMBER(1);
  sl_backup_exst NUMBER(1);
BEGIN
	IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
		RETURN;
	END IF;
  IF "tspkg_Update77To78"."fn_IsObjectExist"('ServiceLevel_backup') = 1 THEN  
	EXECUTE IMMEDIATE 'UPDATE "ServiceLevel" sl
		SET ("ImageId", "Description") = (
			SELECT sl_b."ImageId", sl_b."Description"
			FROM "ServiceLevel_backup" sl_b
			WHERE sl."Id" = sl_b."Id")
		WHERE EXISTS (SELECT "Id"
			FROM "ServiceLevel_backup" sl_b
			WHERE sl."Id" = sl_b."Id")';

	EXECUTE IMMEDIATE 'DROP TABLE "ServiceLevel_backup"';
  END IF;
  
  IF "tspkg_Update77To78"."fn_IsObjectExist"('ServiceLevelImage_backup') = 1 THEN  
	EXECUTE IMMEDIATE 'MERGE INTO "SysImage" si
	  USING (
		SELECT * 
		FROM "ServiceLevelImage_backup" sli_b 
		WHERE sli_b."Id" IN (
		  SELECT "ImageId"
		  FROM "ServiceLevel_backup")) si_b
	  ON (si."Id"=si_b."Id")
	  WHEN NOT MATCHED THEN INSERT (  
		  "Id"
		 ,"CreatedOn"
		 ,"CreatedById"
		 ,"ModifiedOn"
		 ,"ModifiedById"
		 ,"UploadedOn"
		 ,"Name"
		 ,"Data"
		 ,"MimeType"
		 ,"HasRef"
		 ,"PreviewData"
		 ,"ProcessListeners")
		VALUES (   
		  si_b."Id"
		 ,si_b."CreatedOn" 
		 ,si_b."CreatedById" 
		 ,si_b."ModifiedOn" 
		 ,si_b."ModifiedById"
		 ,si_b."UploadedOn"
		 ,si_b."Name" 
		 ,si_b."Data" 
		 ,si_b."MimeType"
		 ,si_b."HasRef"
		 ,si_b."PreviewData"
		 ,si_b."ProcessListeners")';

	EXECUTE IMMEDIATE 'DROP TABLE "ServiceLevelImage_backup"';
  END IF;  
END;
