
DECLARE
  ShowInFunnelSQL NVARCHAR2(350) :=
  	'UPDATE "OpportunityStage"
  	SET "OpportunityStage"."ShowInFunnel" = "OpportunityStage_backup"."ShowInFunnel"
  	FROM "OpportunityStage_backup"
  	INNER JOIN "OpportunityStage" ON "OpportunityStage_backup"."Id" = "OpportunityStage"."Id"';
  ShowInProgressBarSQL NVARCHAR2(350) :=
  	'UPDATE "OpportunityStage"
  	SET "OpportunityStage"."ShowInProgressBar" = "OpportunityStage_backup"."ShowInProgressBar"
  	FROM "OpportunityStage_backup"
  	INNER JOIN "OpportunityStage" ON "OpportunityStage_backup"."Id" = "OpportunityStage"."Id"';
BEGIN
  IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
  	RETURN;
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('OpportunityStage') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('OpportunityStage_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "OpportunityStage" us
    SET (us."Name", us."End", us."Successful", us."Number", us."MaxProbability") = (
      SELECT "Name", "End", "Successful", "Number", "MaxProbability"
      FROM "OpportunityStage_backup" us_b
      WHERE us."Id" = us_b."Id")
	WHERE EXISTS (SELECT "Id"
	   FROM "OpportunityStage_backup" us_b
      WHERE us."Id" = us_b."Id")';
  END IF;
  
  IF ("tspkg_Update77To78"."fn_IsObjectExist"('QualifyStatus') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('QualifyStatus_backup') != 0) THEN
    EXECUTE IMMEDIATE 'UPDATE "QualifyStatus" qs
    SET (qs."Name", qs."StageNumber") = (
      SELECT qs_b."Name", qs_b."StageNumber"
      FROM "QualifyStatus_backup" qs_b
      WHERE qs."Id" = qs_b."Id" )
	WHERE EXISTS (SELECT "Id"
	   FROM "QualifyStatus_backup" qs_b
      WHERE qs."Id" = qs_b."Id" )';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('CaseStatus') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('CaseStatus_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "CaseStatus" cs
  	SET (cs."Name" ,cs."IsFinal" ,cs."IsResolved", cs."IsPaused", cs."ButtonCaption", cs."IsCloseOnSave") = (
      SELECT cs_b."Name", cs_b."IsFinal", cs_b."IsResolved", cs_b."IsPaused", cs_b."ButtonCaption", cs_b."IsCloseOnSave"
      FROM "CaseStatus_backup" cs_b
      WHERE cs."Id" = cs_b."Id")
	WHERE EXISTS (SELECT "Id"
     FROM "CaseStatus_backup" cs_b
      WHERE cs."Id" = cs_b."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('Tax') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('Tax_backup') != 0) THEN
    EXECUTE IMMEDIATE 'UPDATE "Tax" t
  	SET (t."Name", t."Percent") = (
      SELECT t_b."Name", t_b."Percent"
      FROM "Tax_backup" t_b
      WHERE t_b."Id" = t."Id")
	WHERE EXISTS (SELECT "Id"
	  FROM "Tax_backup" t_b
      WHERE t_b."Id" = t."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('SatisfactionLevel') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('SatisfactionLevel_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "SatisfactionLevel" sl
  	SET (sl."Name", sl."Point", sl."Colour", sl."StatusId") = (
      SELECT sl_b."Name", sl_b."Point", sl_b."Colour", sl_b."StatusId"
  	  FROM "SatisfactionLevel_backup" sl_b
  	  WHERE sl_b."Id" = sl."Id")
	WHERE EXISTS (SELECT "Id"
	   FROM "SatisfactionLevel_backup" sl_b
  	  WHERE sl_b."Id" = sl."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('DuplicatesRule') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('DuplicatesRule_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "DuplicatesRule" dr
  	SET dr."IsActive" = (
      SELECT dr_b."IsActive"
  	  FROM "DuplicatesRule_backup" dr_b
  	  WHERE dr_b."Id" = dr."Id")
     WHERE EXISTS ( SELECT "IsActive"
  	  FROM "DuplicatesRule_backup" dr_b
  	  WHERE dr_b."Id" = dr."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('ActivityCategory') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('ActivityCategory_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "ActivityCategory" ac
  	SET (ac."Name", ac."ActivityTypeId") = (
      SELECT ac_b."Name", ac_b."ActivityTypeId"
  	  FROM "ActivityCategory_backup" ac_b
		WHERE ac."Id" = ac_b."Id")
	WHERE EXISTS (SELECT "Id"
		FROM "ActivityCategory_backup" ac_b
		WHERE ac."Id" = ac_b."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('CommunicationType') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('CommunicationType_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "CommunicationType" ct
  	SET (ct."UseforContacts", ct."UseforAccounts", ct."Description",ct."Image", ct."HyperlinkTemplate", ct."Name") = (
      SELECT ct_b."UseforContacts", ct_b."UseforAccounts", ct_b."Description",ct_b."Image", ct_b."HyperlinkTemplate", ct_b."Name"
  	  FROM "CommunicationType_backup" ct_b
  	  WHERE ct_b."Id" = ct."Id")
	WHERE EXISTS (SELECT "Id"
	   FROM "CommunicationType_backup" ct_b
  	  WHERE ct_b."Id" = ct."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('OpportunityMood') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('OpportunityMood_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "OpportunityMood" om
  	SET (om."Name", om."ImageId") = (
      SELECT om_b."Name", om_b."ImageId"
  	  FROM "OpportunityMood_backup" om_b
  	  WHERE om_b."Id" = om."Id")
	WHERE EXISTS (SELECT "Id"
	   FROM "OpportunityMood_backup" om_b
  	  WHERE om_b."Id" = om."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('OpportunityDepartment') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('OpportunityDepartment_backup') != 0) THEN
  	EXECUTE IMMEDIATE 'UPDATE "OpportunityDepartment" od
  	SET (od."Name", od."SalesDirectorId") = (
      SELECT od_b."Name", od_b."SalesDirectorId"
      FROM "OpportunityDepartment_backup" od_b
  	  WHERE od_b."Id" = od."Id")
	WHERE EXISTS (SELECT "Id"
	   FROM "OpportunityDepartment_backup" od_b
  	  WHERE od_b."Id" = od."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('EmailTemplate') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('EmailTemplate_backup') != 0) THEN
  EXECUTE IMMEDIATE 'UPDATE "EmailTemplate" et
  SET (et."ProcessListeners",
    	et."Name",
    	et."ObjectId",
    	et."Recipient" ,
    	et."CopyRecipient",
    	et."BlindCopyRecipient",
    	et."Subject",
    	et."PriorityId",
    	et."Body",
    	et."IsHtmlBody",
    	et."Macros",
    	et."SendIndividualEmailId",
    	et."SaveAsActivity",
    	et."ObjectFieldInActivity",
    	et."ShowBeforeSending",
    	et."TemplateConfig") = (
    SELECT et_b."ProcessListeners",
    	et_b."Name",
    	et_b."ObjectId",
    	et_b."Recipient" ,
    	et_b."CopyRecipient",
    	et_b."BlindCopyRecipient",
    	et_b."Subject",
    	et_b."PriorityId",
    	et_b."Body",
    	et_b."IsHtmlBody",
    	et_b."Macros",
    	et_b."SendIndividualEmailId",
    	et_b."SaveAsActivity",
    	et_b."ObjectFieldInActivity",
    	et_b."ShowBeforeSending",
    	et_b."TemplateConfig"
    FROM "EmailTemplate_backup" et_b
  	WHERE et."Id" = et_b."Id")
  WHERE EXISTS (SELECT "Id"
    FROM "EmailTemplate_backup" et_b
  	WHERE et."Id" = et_b."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('WSysAccount') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('WSysAccount_backup') != 0) THEN
  EXECUTE IMMEDIATE 'UPDATE "WSysAccount" wsa
  SET (wsa."ProcessListeners",
    	wsa."Name",
    	wsa."ContactId",
    	wsa."Login",
    	wsa."Password",
    	wsa."RoleId") = (
    SELECT wsa_b."ProcessListeners",
    	wsa_b."Name",
    	wsa_b."ContactId",
    	wsa_b."Login",
    	wsa_b."Password",
    	wsa_b."RoleId"
    FROM "WSysAccount_backup" wsa_b
    WHERE wsa_b."Id" = wsa."Id")
	WHERE EXISTS (SELECT "Id"
	  FROM "WSysAccount_backup" wsa_b
    WHERE wsa_b."Id" = wsa."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('Forecast') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('Forecast_backup') != 0) THEN
  EXECUTE IMMEDIATE 'UPDATE "Forecast" f
  SET (f."Name",
    	f."EntitySchemaUId",
    	f."EntitySchemaName",
    	f."PeriodTypeId") = (
    SELECT f_b."Name",
    	f_b."EntitySchemaUId",
    	f_b."EntitySchemaName",
    	f_b."PeriodTypeId"
    FROM "Forecast_backup" f_b
    WHERE f_b."Id" = f."Id")
	WHERE EXISTS (SELECT "Id"
	  FROM "Forecast_backup" f_b
    WHERE f_b."Id" = f."Id")';
  END IF;

  IF ("tspkg_Update77To78"."fn_IsObjectExist"('ForecastIndicator') != 0 AND "tspkg_Update77To78"."fn_IsObjectExist"('ForecastIndicator_backup') != 0) THEN
  EXECUTE IMMEDIATE 'UPDATE "ForecastIndicator" f
  SET (f."Name",
    	f."Code",
    	f."Position") = (
    SELECT f_b."Name",
    	f_b."Code",
    	f_b."Position"
    FROM "ForecastIndicator_backup" f_b
    WHERE f_b."Id" = f."Id")
	WHERE EXISTS (SELECT "Id"
	  FROM "ForecastIndicator_backup" f_b
    WHERE f_b."Id" = f."Id")';
  END IF;
END;
