DECLARE
	Id 							VARCHAR2(38);
	Name 						VARCHAR2(2000);
	cmdDropTrigger 				VARCHAR2(2000);
	cmdIsTriggerExistTemplate 	VARCHAR2(2000) := '"tspkg_Update77To78"."fn_IsObjectExist"(''{Name}'')';
	cmdIsTriggerExist			NUMBER;
	cmdTriggerName				VARCHAR2(2000);
	cmdCreateTrigger			VARCHAR2(2000);
	cmdCreateTriggerTemplate	VARCHAR2(2000) := 
	'CREATE TRIGGER "{Name}"
		AFTER UPDATE
		ON "{TableName}"
		FOR EACH ROW
	BEGIN
		IF updating(''Name'') THEN
			INSERT INTO "SysLookupsValues_Backup" (
				"Id", "Name", "TableName", "CreatedOn"
			)
			VALUES (:old."Id", :old."Name", ''{TableName}'', CURRENT_TIMESTAMP);
		END IF;
	END "{Name}";';
	CURSOR tableNameCursor
	IS
		SELECT
			"Id", "Name"
		FROM "SysSchema"
		WHERE "UId" IN (SELECT "SysEntitySchemaUId" FROM "Lookup")
			AND "Name" NOT LIKE 'Vw%'
			AND EXISTS 
				(SELECT *
				FROM "ALL_TAB_COLS"
				WHERE "TABLE_NAME" = "Name"
					AND "COLUMN_NAME" = 'Name');

	l_tableNameCursor	tableNameCursor%ROWTYPE;
BEGIN
	IF ("tspkg_Update77To78"."fn_IsRowsExist"('SysLic') = 0) THEN
		RETURN;
	END IF;
	OPEN tableNameCursor;
	LOOP
		FETCH tableNameCursor INTO l_tableNameCursor;
		EXIT WHEN tableNameCursor%NOTFOUND;
		cmdTriggerName := 'CheckValueUpdate_' || SUBSTR(SYS_GUID(), 1, 10);

		IF "tspkg_Update77To78"."fn_IsObjectExist"(cmdTriggerName) != 0 THEN
			EXECUTE IMMEDIATE 'DROP TRIGGER "' || cmdTriggerName ||'"';
		END IF;

		cmdCreateTrigger := REPLACE(cmdCreateTriggerTemplate, '{Name}', cmdTriggerName);
		cmdCreateTrigger := REPLACE(cmdCreateTrigger, '{TableName}', l_tableNameCursor."Name");
		EXECUTE IMMEDIATE cmdCreateTrigger;
		EXECUTE IMMEDIATE 'INSERT INTO "CheckValueUpdateTriggers"("Id", "TriggerName", "TableName") 
		VALUES("tspkg_Utilities"."fn_CreateGuid"(), ''' || cmdTriggerName || ''', ''' || l_tableNameCursor."Name" || ''')';
	END LOOP;
	CLOSE tableNameCursor;
END;

