DECLARE
  t_exists INT := 0;
  temp_table INT := 0;
  DuplicateEmailResponseId VARCHAR2(38) := '{290F4FDB-D628-4049-BBD4-77572845BA33}';
  BlunkEmailResponseId VARCHAR2(38) := '{8FFDE5F0-CB75-4D90-A757-7E4748491ABF}';
  UnreachableEmailResponseId VARCHAR2(38) := '{59ACDA79-1ACD-47CC-8655-8E74BD2D00D0}';
  IncorrectEmailResponseId VARCHAR2(38) := '{F83922C2-C8A3-4DD0-A688-D59A41E1AB2B}';
  DoNotUseEmailResponseId VARCHAR2(38) := '{BBFB3947-54FF-48C0-A1E5-F46F01A54E6D}';
BEGIN
  SELECT COUNT(*)
    INTO t_exists
    FROM USER_TABLES
    WHERE table_name = UPPER('BulkEmail');
  IF t_exists = 0
  THEN
    MERGE INTO "BulkEmail" USING (
     SELECT
    	tmp."BulkEmailId"
       ,SUM(tmp."DuplicateEmail") as "DuplicateCount"
       ,SUM(tmp."BlankEmail") as "BlankCount"
       ,SUM(tmp."UnreachableEmail") as "UnreachableCount"
       ,SUM(tmp."IncorrectEmail") as "IncorrectCount"
       ,SUM(tmp."DoNotUseEmail") as "DoNotUseCount"
    FROM (SELECT
    		bet."BulkEmailId" AS "BulkEmailId"
    	   ,CASE
    			WHEN bet."BulkEmailResponseId" = DuplicateEmailResponseId THEN 1
    			ELSE 0
    		END "DuplicateEmail"
    	   ,CASE
    			WHEN bet."BulkEmailResponseId" = BlunkEmailResponseId THEN 1
    			ELSE 0
    		END "BlankEmail"
    	   ,CASE
    			WHEN bet."BulkEmailResponseId" = UnreachableEmailResponseId THEN 1
    			ELSE 0
    		END "UnreachableEmail"
    	   ,CASE
    			WHEN bet."BulkEmailResponseId" = IncorrectEmailResponseId THEN 1
    			ELSE 0
    		END "IncorrectEmail"
    	   ,CASE
    			WHEN bet."BulkEmailResponseId" = DoNotUseEmailResponseId THEN 1
    			ELSE 0
    		END "DoNotUseEmail"
    	FROM "BulkEmailTarget" bet) tmp
    GROUP BY tmp."BulkEmailId") counters
      ON  (counters."BulkEmailId" = "BulkEmail"."Id") 
      WHEN MATCHED THEN
    UPDATE SET 
      "DuplicateEmailCount" = counters."DuplicateCount",
      "UnreachableEmailCount" = counters."UnreachableCount",
      "BlankEmailCount" = counters."BlankCount",
      "IncorrectEmailCount" = counters."IncorrectCount",
      "DoNotUseEmailCount" = counters."DoNotUseCount";  
  END IF;
END;